/* -*- buffer-read-only: t -*- vi: set ro:
#line 426
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
#line 426
*/
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif
#include <sys/types.h>
#include "mailfromd.h"
#include "prog.h"
#include "builtin.h"

#line 17 "bi_dns.m4"
/* This file is part of mailfromd.             -*- c -*-
#line 17
   Copyright (C) 2006, 2007 Sergey Poznyakoff
#line 17

#line 17
   This program is free software; you can redistribute it and/or modify
#line 17
   it under the terms of the GNU General Public License as published by
#line 17
   the Free Software Foundation; either version 2, or (at your option)
#line 17
   any later version.
#line 17

#line 17
   This program is distributed in the hope that it will be useful,
#line 17
   but WITHOUT ANY WARRANTY; without even the implied warranty of
#line 17
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#line 17
   GNU General Public License for more details.
#line 17

#line 17
   You should have received a copy of the GNU General Public License
#line 17
   along with this program; if not, write to the Free Software
#line 17
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#line 17
   MA 02110-1301 USA */

#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>

void
#line 24
bi_primitive_hostname(eval_environ_t env)
#line 24

#line 24 "bi_dns.m4"
{
#line 24
	
#line 24
char * string = (char *) get_string_arg(env, 0);
#line 24
        
#line 24
        adjust_stack(env, 1);
#line 24

#line 24
	if (prog_trace_option & BUILTIN_MASK_dns)
#line 24
		prog_trace(env, "primitive_hostname %s",string);;
#line 24

{
	char *hbuf;
	mf_status stat;

	stat = resolve_ipstr(string, &hbuf);
		if (!(stat == mf_success))
#line 33
			env_throw(env, stat,                                             "primitive_hostname: " "Cannot resolve IP %s",string);
#line 33
;
#line 33
;
	
	pushs(env, hbuf);
	free(hbuf);
}
}

void
#line 40
bi_primitive_resolve(eval_environ_t env)
#line 40

#line 40 "bi_dns.m4"
{
#line 40
	
#line 40
char * string = (char *) get_string_arg(env, 1);
#line 40
        char * domain = (char *) get_string_arg(env, 0);
#line 40
        
#line 40
        adjust_stack(env, 2);
#line 40

#line 40
	if (prog_trace_option & BUILTIN_MASK_dns)
#line 40
		prog_trace(env, "primitive_resolve %s %s",string, domain);;
#line 40

{
	char *ipstr;
	mf_status stat;
	
	if ((domain && domain[0])) {
		stat = resolve_ipstr_domain(string, domain, &ipstr);
			if (!(stat == mf_success))
#line 49
			env_throw(env, stat,                                             "primitive_resolve: " "Cannot resolve %s.%s",string,domain);
#line 49
;
#line 49
;
	} else {
		stat = resolve_hostname(string, &ipstr);
			if (!(stat == mf_success))
#line 54
			env_throw(env, stat,                                             "primitive_resolve: " "Cannot resolve %s",string);
#line 54
;
#line 54
;
	}
	pushs(env, ipstr);
	free(ipstr);
}
}

static int
ipaddr_cmp(const void *a, const void *b)
{
	GACOPYZ_UINT32_T ipa = ntohl(*(GACOPYZ_UINT32_T*)a);
	GACOPYZ_UINT32_T ipb = ntohl(*(GACOPYZ_UINT32_T*)b);
	if (ipa < ipb)
		return -1;
	if (ipa > ipb)
		return 1;
	return 0;
}

void
#line 73
bi_dns_getaddr(eval_environ_t env)
#line 73

#line 73 "bi_dns.m4"
{
#line 73
	
#line 73
char * string = (char *) get_string_arg(env, 0);
#line 73
        
#line 73
        adjust_stack(env, 1);
#line 73

#line 73
	if (prog_trace_option & BUILTIN_MASK_dns)
#line 73
		prog_trace(env, "dns_getaddr %s",string);;
#line 73

{
	char *ipstr;
	mf_status stat;
	GACOPYZ_UINT32_T ipbuf[64]; /* FIXME: arbitrary limit */
	size_t i, ipcount;
	unsigned long ttl;
	dns_status dnstat;

	dnstat = a_lookup(string, ipbuf, NELEMS(ipbuf), &ipcount,
			  &ttl, NULL, 0);
	switch (dnstat) {
	case dns_success: {
		size_t ns;
		char *p;
		size_t size;
#line 88
char *s = heap_max_tempspace(env, &size)
#line 88
;

		qsort(ipbuf, ipcount, sizeof ipbuf[0], ipaddr_cmp);
		for (i = 0, ns = 0, p = s; i < ipcount; i++) {
			size_t len;
			struct in_addr addr;
			char *q;
			
			addr.s_addr = ipbuf[i];
			q = inet_ntoa(addr);
			len = strlen(q);
			if (ns + len + 1 > size)
				break;
			if (i > 0)
				*p++ = ' ';
			memcpy(p, q, len);
			p += len;
			ns += len + 1;
		}
		*p = 0;
		
#line 108
do {
#line 108
push(env, (STKVAL) (heap_fix_tempspace(env, ns)));
#line 108
return;
#line 108
} while (0);
	}
	case dns_not_found:
		do {pushs(env, "");
#line 111
return;
#line 111
} while (0);
	default:
			env_throw(env, dns_to_mf_status(dnstat),                                             "dns_getaddr: " "failed to get A record for %s",string);
;
	}
}
}

static int
hostname_cmp(const void *a, const void *b)
{
	return strcmp(*(const char**) a, *(const char**) b);
}

void
#line 125
bi_dns_getname(eval_environ_t env)
#line 125

#line 125 "bi_dns.m4"
{
#line 125
	
#line 125
char * ipstr = (char *) get_string_arg(env, 0);
#line 125
        
#line 125
        adjust_stack(env, 1);
#line 125

#line 125
	if (prog_trace_option & BUILTIN_MASK_dns)
#line 125
		prog_trace(env, "dns_getname %s",ipstr);;
#line 125

{
	dns_status dnstat;
	struct in_addr addr;
	unsigned long ttl;
	char *names[64], **p;

		if (!(inet_aton(ipstr, &addr)))
#line 134
			env_throw(env, mf_invip,                                             "dns_getname: " "Invalid IP: %s",ipstr);
#line 134
;
#line 134
;

	dnstat = ptr_lookup(addr, names, NELEMS(names), &ttl, NULL, 0);
	switch (dnstat) {
	case dns_success: {
		size_t i, ns;
		size_t ncount;
		char *p;
		size_t size;
#line 142
char *s = heap_max_tempspace(env, &size)
#line 142
;

		for (ncount = 0; ncount < NELEMS(names) && names[ncount];
		     ncount++);
		
		qsort(names, ncount, sizeof names[0], hostname_cmp);

		for (i = 0, ns = 0, p = s; i < ncount; i++) {
			size_t len;
			
			len = strlen(names[i]);
			if (ns + len + 1 > size)
				break;
			if (i > 0)
				*p++ = ' ';
			memcpy(p, names[i], len);
			p += len;
			ns += len + 1;
			free(names[i]);
		}
		*p = 0;

		for (; i < ncount; i++) 
			free(names[i]);
		
		
#line 167
do {
#line 167
push(env, (STKVAL) (heap_fix_tempspace(env, ns)));
#line 167
return;
#line 167
} while (0);
	}
	case dns_not_found:
		do {pushs(env, "");
#line 170
return;
#line 170
} while (0);
	default:
			env_throw(env, dns_to_mf_status(dnstat),                                             "dns_getname: " "failed to get PTR record for %s",ipstr);
;
	}
}
}

void
#line 178
bi_primitive_hasmx(eval_environ_t env)
#line 178

#line 178 "bi_dns.m4"
{
#line 178
	
#line 178
char * string = (char *) get_string_arg(env, 0);
#line 178
        
#line 178
        adjust_stack(env, 1);
#line 178

#line 178
	if (prog_trace_option & BUILTIN_MASK_dns)
#line 178
		prog_trace(env, "primitive_hasmx %s",string);;
#line 178

{
	mxbuf_t mxbuf;
	mf_status mxstat;

	mxstat = getmx(string, mxbuf);
	
		if (!(mxstat == mf_success || mxstat == mf_not_found))
#line 188
			env_throw(env, mxstat,                                             "primitive_hasmx: " "Cannot get MXs for %s",string);
#line 188
;
#line 188
;

	if (mxstat == mf_success) {
		dns_freemx(mxbuf);
		do {
#line 192
push(env, (STKVAL) (1));
#line 192
return;
#line 192
} while (0);
	}
	do {
#line 194
push(env, (STKVAL) (0));
#line 194
return;
#line 194
} while (0);
}
}

void
#line 198
bi_getmx(eval_environ_t env)
#line 198

#line 198 "bi_dns.m4"
{
#line 198
	
#line 198
char * domain = (char *) get_string_arg(env, 1);
#line 198
        long  resolve = (long ) get_numeric_arg(env, 0);
#line 198
        
#line 198
        adjust_stack(env, 2);
#line 198

#line 198
	if (prog_trace_option & BUILTIN_MASK_dns)
#line 198
		prog_trace(env, "getmx %s %lu",domain, resolve);;
#line 198

{
	mxbuf_t mxbuf;
	mf_status mxstat;
	int i;

	if ((resolve))
		mxstat = getmxip(domain, mxbuf);
	else
		mxstat = getmx(domain, mxbuf);
		if (!(mxstat == mf_success || mxstat == mf_not_found))
#line 210
			env_throw(env, mxstat,                                             "getmx: " "Cannot get MX records for %s",domain);
#line 210
;
#line 210
;
	if (mxstat == mf_not_found)
		do {pushs(env, "");
#line 212
return;
#line 212
} while (0);
	else {
		int i;
		size_t ns;
		char *p;
		
		size_t size;
#line 218
char *s = heap_max_tempspace(env, &size)
#line 218
;
		
		for (i = 0, ns = 0, p = s; i < MAXMXCOUNT && mxbuf[i]; i++) {
			size_t len = strlen(mxbuf[i]);
			if (ns + len + 1 > size)
				break;
			if (i > 0)
				*p++ = ' ';
			memcpy(p, mxbuf[i], len);
			p += len;
			ns += len + 1;
		}
		*p = 0;
		dns_freemx(mxbuf);
		
#line 232
do {
#line 232
push(env, (STKVAL) (heap_fix_tempspace(env, ns)));
#line 232
return;
#line 232
} while (0);
	}
}
}

static int
resolve_host(const char *string, unsigned long *ip)
{
	int rc;
	struct in_addr addr;
	char *ipstr;

	if (inet_aton(string, &addr)) {
		*ip = addr.s_addr;
		return 0;
	}
	
	if (resolve_hostname(string, &ipstr) != mf_success)
		return 1;

	rc = inet_aton(ipstr, &addr);
	free(ipstr);
	if (rc == 0) {
		mu_error("INTERNAL ERROR at %s:%lu: resolve_hostname returned "
			 "invalid IP address: %s",
			 __FILE__, __FILE__, ipstr);
		return 1;
	}
	*ip = addr.s_addr;
	return 0;
}

void
#line 264
bi_primitive_ismx(eval_environ_t env)
#line 264

#line 264 "bi_dns.m4"
{
#line 264
	
#line 264
char * domain = (char *) get_string_arg(env, 1);
#line 264
        char * ipstr = (char *) get_string_arg(env, 0);
#line 264
        
#line 264
        adjust_stack(env, 2);
#line 264

#line 264
	if (prog_trace_option & BUILTIN_MASK_dns)
#line 264
		prog_trace(env, "primitive_ismx %s %s",domain, ipstr);;
#line 264

{
	mxbuf_t mxbuf;
	mf_status mxstat;
	unsigned long ip;
	int rc = 0;
	int i;
	
		if (!(resolve_host(ipstr, &ip) == 0))
			env_throw(env, mf_noresolve,                                             "primitive_ismx: " "cannot resolve host name %s",ipstr);
#line 273
;
#line 273
;
	
	mxstat = getmx(domain, mxbuf);
	
		if (!(mxstat == mf_success))
#line 279
			env_throw(env, mxstat,                                             "primitive_ismx: " "Cannot get MXs for %s",domain);
#line 279
;
#line 279
;

	for (i = 0; i < MAXMXCOUNT && mxbuf[i]; i++) {
		unsigned long n;
		
		if (!resolve_host(mxbuf[i], &n) && n == ip) {
			rc = 1;
			break;
		}
	}
	dns_freemx(mxbuf);
	do {
#line 290
push(env, (STKVAL) (rc));
#line 290
return;
#line 290
} while (0);
}
}

void
#line 294
bi_relayed(eval_environ_t env)
#line 294

#line 294 "bi_dns.m4"
{
#line 294
	
#line 294
char * s = (char *) get_string_arg(env, 0);
#line 294
        
#line 294
        adjust_stack(env, 1);
#line 294

#line 294
	if (prog_trace_option & BUILTIN_MASK_dns)
#line 294
		prog_trace(env, "relayed %s",s);;
#line 294

{
	do {
#line 296
push(env, (STKVAL) (relayed_domain_p(s)));
#line 296
return;
#line 296
} while (0);
}
}

void
#line 300
bi_listens(eval_environ_t env)
#line 300

#line 300 "bi_dns.m4"
{
#line 300
	
#line 300
char * s = (char *) get_string_arg(env, 1);
#line 300
        long  port = (long ) get_numeric_arg(env, 0);
#line 300
        
#line 300
        adjust_stack(env, 2);
#line 300

#line 300
	if (prog_trace_option & BUILTIN_MASK_dns)
#line 300
		prog_trace(env, "listens %s %lu",s, port);;
#line 300

{
	do {
#line 302
push(env, (STKVAL) (listens_on (s, ((port) ? port : 25) == mf_success)));
#line 302
return;
#line 302
} while (0);
}
}

void
#line 306
bi_domainpart(eval_environ_t env)
#line 306

#line 306 "bi_dns.m4"
{
#line 306
	
#line 306
char * str = (char *) get_string_arg(env, 0);
#line 306
        
#line 306
        adjust_stack(env, 1);
#line 306

#line 306
	if (prog_trace_option & BUILTIN_MASK_dns)
#line 306
		prog_trace(env, "domainpart %s",str);;
#line 306

{
	char *p = strchr(str, '@');
	do {pushs(env, p ? p+1 : str);
#line 309
return;
#line 309
} while (0);
}
}

void
#line 313
bi_localpart(eval_environ_t env)
#line 313

#line 313 "bi_dns.m4"
{
#line 313
	
#line 313
char * str = (char *) get_string_arg(env, 0);
#line 313
        
#line 313
        adjust_stack(env, 1);
#line 313

#line 313
	if (prog_trace_option & BUILTIN_MASK_dns)
#line 313
		prog_trace(env, "localpart %s",str);;
#line 313

{
	char *p = strchr(str, '@');

	if (p) {
		size_t off;
		size_t size = p - str;
		char *string_space = (char*) env_data_ref(env, (off = heap_reserve(env, size + 1)));
		memcpy(string_space, str, size);
		string_space[size] = 0;
		do {
#line 323
push(env, (STKVAL) (off));
#line 323
return;
#line 323
} while (0);
	} else
		do {pushs(env, str);
#line 325
return;
#line 325
} while (0);
}
}


#line 329
void
#line 329
dns_init_builtin()
#line 329
{
#line 329
	#line 24 "bi_dns.m4"
va_builtin_install_ex("primitive_hostname", bi_primitive_hostname, 0, 0, dtype_string,  1, 0,  dtype_string);
#line 40 "bi_dns.m4"
va_builtin_install_ex("primitive_resolve", bi_primitive_resolve, 0, 0, dtype_string,  2, 1,  dtype_string, dtype_string);
#line 73 "bi_dns.m4"
va_builtin_install_ex("dns_getaddr", bi_dns_getaddr, 0, 0, dtype_string,  1, 0,  dtype_string);
#line 125 "bi_dns.m4"
va_builtin_install_ex("dns_getname", bi_dns_getname, 0, 0, dtype_string,  1, 0,  dtype_string);
#line 178 "bi_dns.m4"
va_builtin_install_ex("primitive_hasmx", bi_primitive_hasmx, 0, 0, dtype_number,  1, 0,  dtype_string);
#line 198 "bi_dns.m4"
va_builtin_install_ex("getmx", bi_getmx, 0, 0, dtype_string,  2, 1,  dtype_string, dtype_number);
#line 264 "bi_dns.m4"
va_builtin_install_ex("primitive_ismx", bi_primitive_ismx, 0, 0, dtype_number,  2, 0,  dtype_string, dtype_string);
#line 294 "bi_dns.m4"
va_builtin_install_ex("relayed", bi_relayed, 0, 0, dtype_number,  1, 0,  dtype_string);
#line 300 "bi_dns.m4"
va_builtin_install_ex("listens", bi_listens, 0, 0, dtype_number,  2, 1,  dtype_string, dtype_number);
#line 306 "bi_dns.m4"
va_builtin_install_ex("domainpart", bi_domainpart, 0, 0, dtype_string,  1, 0,  dtype_string);
#line 313 "bi_dns.m4"
va_builtin_install_ex("localpart", bi_localpart, 0, 0, dtype_string,  1, 0,  dtype_string);

#line 329 "bi_dns.m4"
		
#line 329
}
#line 0

#line 0

