/* -*- buffer-read-only: t -*- vi: set ro:
#line 426
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
#line 426
*/
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif
#include <sys/types.h>
#include "mailfromd.h"
#include "prog.h"
#include "builtin.h"

#line 17 "bi_io.m4"
/* This file is part of mailfromd.             -*- c -*-
#line 17
   Copyright (C) 2006, 2007 Sergey Poznyakoff
#line 17

#line 17
   This program is free software; you can redistribute it and/or modify
#line 17
   it under the terms of the GNU General Public License as published by
#line 17
   the Free Software Foundation; either version 2, or (at your option)
#line 17
   any later version.
#line 17

#line 17
   This program is distributed in the hope that it will be useful,
#line 17
   but WITHOUT ANY WARRANTY; without even the implied warranty of
#line 17
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#line 17
   GNU General Public License for more details.
#line 17

#line 17
   You should have received a copy of the GNU General Public License
#line 17
   along with this program; if not, write to the Free Software
#line 17
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#line 17
   MA 02110-1301 USA */

#include <sys/types.h>
#include <sys/stat.h>
#include <sys/wait.h>

#define NSTREAMS 1024

struct io_stream {
	char *name;
	mu_locker_t lock;
	int fd[2];
	pid_t pid;
	char *buf;
	size_t bufsize;
};

#define IFD(s) ((s).fd[0])
#define OFD(s) ((s).fd[1] == -1 ? (s).fd[0] : (s).fd[1])

static void
flush_stream(struct io_stream *str)
{
	/*FIXME*/
}

static void
close_stream(struct io_stream *str)
{
	if (OFD(*str) == -1)
		return;
	flush_stream(str);
	close(OFD(*str));
	if (IFD(*str) != -1)
		close(IFD(*str));
	if (str->pid) {
		int status;
		waitpid(str->pid, &status, 0);
	}
	str->fd[0] = -1;
	str->fd[1] = -1;
	str->pid = 0;
}

static int
read_stream_line(struct io_stream *str)
{
	int fd = IFD(*str);
	size_t i = 0;
	int rc;

	for (i = 0; ; i++) {
		if (str->bufsize == i) {
			if (str->bufsize == 0) 
				str->bufsize = 16;
			str->buf = x2nrealloc(str->buf, &str->bufsize,
					      sizeof str->buf[1]);
		}
		rc = read(fd, str->buf + i, 1);
		if (rc == -1)
			return -1;
		if (str->buf[i] == '\n') {
			str->buf[i] = 0;
			break;
		}
	}
	return 0;
}

#define REDIRECT_STDIN_P(f) ((f) & (O_WRONLY|O_RDWR))
#define REDIRECT_STDOUT_P(f) ((f) == O_RDONLY || ((f) & (O_RDONLY|O_RDWR)))

#if defined HAVE_SYSCONF && defined _SC_OPEN_MAX
# define getmaxfd() sysconf(_SC_OPEN_MAX)
#elif defined (HAVE_GETDTABLESIZE)
# define getmaxfd() getdtablesize()
#else
# define getmaxfd() 64
#endif

static int
open_program_stream(struct io_stream *str, const char *cmdline, int flags)
{
	int rightp[2], leftp[2];
	int i;
	int rc = 0;
	pid_t pid;
	int argc;
	char **argv;
	
	if (REDIRECT_STDIN_P(flags))
		pipe(leftp);
	if (REDIRECT_STDOUT_P(flags))
		pipe(rightp);

	switch (pid = fork()) {
		/* The child branch.  */
	case 0:
		/* attach the pipes */

		/* Right-end */
		if (REDIRECT_STDOUT_P(flags)) {
			if (rightp[1] != 1) {
				close(1);
				dup2(rightp[1], 1);
			}
			close(rightp[0]);
		}

		/* Left-end */
		if (REDIRECT_STDIN_P(flags)) {
			if (leftp[0] != 0) {
				close(0);
				dup2(leftp[0], 0);
			}
			close(leftp[1]);
		}
      
		/* FIXME: Error output */
#if 0
		if (errfile) {
			i = open (errfile, O_CREAT|O_WRONLY|O_APPEND, 0644);
			if (i > 0 && i != 2) {
				dup2(i, 2);
				close(i);
			}
		}
#endif	
		/* Close unneded descripitors */
		for (i = getmaxfd(); i > 2; i--)
			close(i);

		debug1(10, "running %s", cmdline);
		rc = mu_argcv_get(cmdline, "", NULL, &argc, &argv);
		if (rc) {
			mu_error("Cannot parse command line %s: %s",
				 cmdline, mu_strerror(rc));
			exit(127);
		}			
		execvp(argv[0], argv);
		mu_error("Cannot run %s: %s",
			 cmdline, mu_strerror(rc));
		exit(127);
		/********************/

		/* Parent branches: */
	case -1:
		/* Fork has failed */
		/* Restore things */
		rc = errno;
		if (REDIRECT_STDOUT_P (flags)) {
			close(rightp[0]);
			close(rightp[1]);
		}
		if (REDIRECT_STDIN_P(flags)) {
			close(leftp[0]);
			close(leftp[1]);
		}
		break;
		
	default:
		str->pid = pid;
		if (REDIRECT_STDOUT_P(flags)) {
			str->fd[0] = rightp[0];
			close(rightp[1]);
		} else
			str->fd[0] = -1;

		if (REDIRECT_STDIN_P(flags)) {
			str->fd[1] = leftp[1];
			close(leftp[0]);
		} else
			str->fd[1] = -1;
	}
	return rc;
}
	
static int
open_file_stream(struct io_stream *str, const char *file, int flags)
{
	str->fd[0] = open(file, flags, 0644); /* FIXME: mode? */
	if (str->fd[0] == -1)
		return errno;
	return 0;
}

static void *
alloc_streams()
{
	struct io_stream *p, *stab = xcalloc(NSTREAMS, sizeof *stab);
	for (p = stab; p < stab + NSTREAMS; p++) 
		p->fd[0] = p->fd[1] = -1;
	return stab;
}

static void
destroy_streams(void *data)
{
	struct io_stream *stab = data;
	struct io_stream *p;
	for (p = stab; p < stab + NSTREAMS; p++) {
		close_stream(p);
		free(p->buf);
	}
	free(stab);
}
		

#line 224

#line 224
static int IO_id;
#line 224 "bi_io.m4"



void
#line 227
bi_open(eval_environ_t env)
#line 227

#line 227 "bi_io.m4"
{
#line 227
	
#line 227
char * name = (char *) get_string_arg(env, 0);
#line 227
        
#line 227
        adjust_stack(env, 1);
#line 227

#line 227
	if (prog_trace_option & BUILTIN_MASK_io)
#line 227
		prog_trace(env, "open %s",name);;
#line 227

{
	int i, rc;
	int flags = 0;
	int (*opf)(struct io_stream *, const char *, int) = open_file_stream;
	struct io_stream *iotab = env_get_builtin_priv(env,IO_id);
	
	for (i = 0; i < NSTREAMS; i++) {
		if (iotab[i].fd[0] == -1) 
			break;
	}
		if (!(i < NSTREAMS))
#line 240
			env_throw(env, mf_failure,                                             "open: " "no more files available");
#line 240
;
#line 240
;

	debug1(10, "opening stream %s", name);
	iotab[i].name = name;
	if (*name == '>') {
		flags |= O_RDWR|O_CREAT;
		name++;
		if (*name == '>') {
			flags |= O_APPEND;
			name++;
		} else
			flags |= O_TRUNC;
	} else if (*name == '|') {
		opf = open_program_stream;
		flags = O_WRONLY;
		name++;
		if (*name == '&') {
			flags = O_RDWR;
			name++;
		} 
	} else
		flags = O_RDWR;
	
	for (;*name && isspace(*name); name++)
		;
	
	rc = opf(&iotab[i], name, flags);
	
		if (!(rc == 0))
#line 271
			env_throw(env, mf_failure,                                             "open: " "cannot open stream %s: %s",name,mu_strerror(rc));
#line 271
;
#line 271
;
	debug2(10, "open(%s) = %d", name, i);
	do {
#line 273
push(env, (STKVAL) (i));
#line 273
return;
#line 273
} while (0);
}
}

void
#line 277
bi_close(eval_environ_t env)
#line 277

#line 277 "bi_io.m4"
{
#line 277
	
#line 277
long  fd = (long ) get_numeric_arg(env, 0);
#line 277
        
#line 277
        adjust_stack(env, 1);
#line 277

#line 277
	if (prog_trace_option & BUILTIN_MASK_io)
#line 277
		prog_trace(env, "close %lu",fd);;
#line 277

{
	struct io_stream *iotab = env_get_builtin_priv(env,IO_id);

		if (!(fd >= 0 && fd < NSTREAMS))
#line 283
			env_throw(env, mf_range,                                             "close: " "invalid file descriptor");
#line 283
;
#line 283
;
	close_stream(&iotab[fd]);
}
}	

void
#line 288
bi_write(eval_environ_t env)
#line 288

#line 288 "bi_io.m4"
{
#line 288
	
#line 288
long  fd = (long ) get_numeric_arg(env, 1);
#line 288
        char * str = (char *) get_string_arg(env, 0);
#line 288
        
#line 288
        adjust_stack(env, 2);
#line 288

#line 288
	if (prog_trace_option & BUILTIN_MASK_io)
#line 288
		prog_trace(env, "write %lu %s",fd, str);;
#line 288

{
	struct io_stream *iotab = env_get_builtin_priv(env,IO_id);
	int n, rc;
	
	debug2(10, "writing %s to %d", str, fd);
		if (!(fd >= 0 && fd < NSTREAMS && OFD(iotab[fd])))
#line 296
			env_throw(env, mf_range,                                             "write: " "invalid file descriptor");
#line 296
;
#line 296
;
	n = strlen(str);
	rc = write(OFD(iotab[fd]), str, n);
		if (!(n == rc))
#line 302
			env_throw(env, mf_ioerr,                                             "write: " "write error on %s: %s",iotab[fd].name,mu_strerror(errno));
#line 302
;
#line 302
;
}
}

void
#line 306
bi_getline(eval_environ_t env)
#line 306

#line 306 "bi_io.m4"
{
#line 306
	
#line 306
long  fd = (long ) get_numeric_arg(env, 0);
#line 306
        
#line 306
        adjust_stack(env, 1);
#line 306

#line 306
	if (prog_trace_option & BUILTIN_MASK_io)
#line 306
		prog_trace(env, "getline %lu",fd);;
#line 306

{
	struct io_stream *iotab = env_get_builtin_priv(env,IO_id);
	int rc;

		if (!(fd >= 0 && fd < NSTREAMS && IFD(iotab[fd])))
#line 313
			env_throw(env, mf_range,                                             "getline: " "invalid file descriptor");
#line 313
;
#line 313
;
	rc = read_stream_line(&iotab[fd]);
		if (!(rc == 0))
#line 318
			env_throw(env, mf_ioerr,                                             "getline: " "read error on %s: %s",iotab[fd].name,mu_strerror(errno));
#line 318
;
#line 318
;
	do {pushs(env, iotab[fd].buf);
#line 319
return;
#line 319
} while (0);
}	
}


#line 323
void
#line 323
io_init_builtin()
#line 323
{
#line 323
	#line 224 "bi_io.m4"
IO_id = builtin_priv_register(alloc_streams, destroy_streams);
#line 227 "bi_io.m4"
va_builtin_install_ex("open", bi_open, 0, 0, dtype_number,  1, 0,  dtype_string);
#line 277 "bi_io.m4"
va_builtin_install_ex("close", bi_close, 0, 0, dtype_unspecified,  1, 0,  dtype_number);
#line 288 "bi_io.m4"
va_builtin_install_ex("write", bi_write, 0, 0, dtype_unspecified,  2, 0,  dtype_number, dtype_string);
#line 306 "bi_io.m4"
va_builtin_install_ex("getline", bi_getline, 0, 0, dtype_string,  1, 0,  dtype_number);

#line 323 "bi_io.m4"
		
#line 323
}
#line 0

#line 0

