/* -*- buffer-read-only: t -*- vi: set ro:
#line 426
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
#line 426
*/
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif
#include <sys/types.h>
#include "mailfromd.h"
#include "prog.h"
#include "builtin.h"

#line 17 "bi_poll.m4"
/* This file is part of mailfromd.             -*- c -*-
#line 17
   Copyright (C) 2006, 2007 Sergey Poznyakoff
#line 17

#line 17
   This program is free software; you can redistribute it and/or modify
#line 17
   it under the terms of the GNU General Public License as published by
#line 17
   the Free Software Foundation; either version 2, or (at your option)
#line 17
   any later version.
#line 17

#line 17
   This program is distributed in the hope that it will be useful,
#line 17
   but WITHOUT ANY WARRANTY; without even the implied warranty of
#line 17
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#line 17
   GNU General Public License for more details.
#line 17

#line 17
   You should have received a copy of the GNU General Public License
#line 17
   along with this program; if not, write to the Free Software
#line 17
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#line 17
   MA 02110-1301 USA */

static size_t last_poll_host_loc
#line 19 "bi_poll.m4"
;
static size_t last_poll_send_loc
#line 20 "bi_poll.m4"
;
static size_t last_poll_recv_loc
#line 21 "bi_poll.m4"
;
static size_t cache_used_loc
#line 22 "bi_poll.m4"
;

void
set_last_poll_result(eval_environ_t env,
		     const char *host_addr,
		     const char *send, const char *recv)
{
	size_t s;

	
#line 31
{ size_t off;
#line 31
  if (host_addr)
#line 31
     strcpy((char*)env_data_ref(env, off = heap_reserve(env, strlen(host_addr) + 1)), host_addr);
#line 31
  else
#line 31
     off = 0;
#line 31
  *env_data_ref(env, last_poll_host_loc) = (STKVAL) (off); }
#line 31
;
	
#line 32
{ size_t off;
#line 32
  if (send)
#line 32
     strcpy((char*)env_data_ref(env, off = heap_reserve(env, strlen(send) + 1)), send);
#line 32
  else
#line 32
     off = 0;
#line 32
  *env_data_ref(env, last_poll_send_loc) = (STKVAL) (off); }
#line 32
;
	
#line 33
{ size_t off;
#line 33
  if (recv)
#line 33
     strcpy((char*)env_data_ref(env, off = heap_reserve(env, strlen(recv) + 1)), recv);
#line 33
  else
#line 33
     off = 0;
#line 33
  *env_data_ref(env, last_poll_recv_loc) = (STKVAL) (off); }
#line 33
;
}

void
set_cache_used(eval_environ_t env, int value)
{
	*env_data_ref(env, cache_used_loc) = (STKVAL) (value);
}


void
#line 43
bi_stdpoll(eval_environ_t env)
#line 43

#line 43 "bi_poll.m4"
{
#line 43
	
#line 43
char * email = (char *) get_string_arg(env, 2);
#line 43
        char * ehlo = (char *) get_string_arg(env, 1);
#line 43
        char * mailfrom = (char *) get_string_arg(env, 0);
#line 43
        
#line 43
        adjust_stack(env, 3);
#line 43

#line 43
	if (prog_trace_option & BUILTIN_MASK_poll)
#line 43
		prog_trace(env, "stdpoll %s %s %s",email, ehlo, mailfrom);;
#line 43

{
	mf_status rc;
	const struct locus *locus = env_get_locus(env);

	trace("%s%s:%lu: STANDARD POLL FOR %s FROM %s AS %s",
	      mailfromd_msgid(env_get_context(env)),
	      locus->file, locus->line,
	      email, ehlo, mailfrom);
	rc = method_standard(env, email, ehlo, mailfrom);
		if (!(mf_resolved(rc)))
			env_throw(env, rc,                                             "stdpoll: " "unhandled exception %s",mf_status_str(rc));
#line 54
;
#line 54
;
			
	do {
#line 56
push(env, (STKVAL) (rc));
#line 56
return;
#line 56
} while (0);	
}
}

#line 61
void
#line 61
bi_strictpoll(eval_environ_t env)
#line 61

#line 61 "bi_poll.m4"
{
#line 61
	
#line 61
char * host = (char *) get_string_arg(env, 3);
#line 61
        char * email = (char *) get_string_arg(env, 2);
#line 61
        char * ehlo = (char *) get_string_arg(env, 1);
#line 61
        char * mailfrom = (char *) get_string_arg(env, 0);
#line 61
        
#line 61
        adjust_stack(env, 4);
#line 61

#line 61
	if (prog_trace_option & BUILTIN_MASK_poll)
#line 61
		prog_trace(env, "strictpoll %s %s %s %s",host, email, ehlo, mailfrom);;
#line 61

{
	mf_status rc;
	const struct locus *locus = env_get_locus(env);

	trace("%s%s:%lu: STRICT POLL FOR %s HOST %s FROM %s AS %s",
	      mailfromd_msgid(env_get_context(env)),
	      locus->file, locus->line,
	      email, host,
	      ehlo, mailfrom);

	rc = method_strict(env, email, host, ehlo, mailfrom);
		if (!(mf_resolved(rc)))
			env_throw(env, rc,                                             "strictpoll: " "unhandled exception %s",mf_status_str(rc));
#line 74
;
#line 74
;
	
	do {
#line 76
push(env, (STKVAL) (rc));
#line 76
return;
#line 76
} while (0);	
}
}

#line 81
void
#line 81
bi__pollhost(eval_environ_t env)
#line 81

#line 81 "bi_poll.m4"
{
#line 81
	
#line 81
char * host = (char *) get_string_arg(env, 3);
#line 81
        char * email = (char *) get_string_arg(env, 2);
#line 81
        char * ehlo = (char *) get_string_arg(env, 1);
#line 81
        char * mailfrom = (char *) get_string_arg(env, 0);
#line 81
        
#line 81
        adjust_stack(env, 4);
#line 81

#line 81
	if (prog_trace_option & BUILTIN_MASK_poll)
#line 81
		prog_trace(env, "_pollhost %s %s %s %s",host, email, ehlo, mailfrom);;
#line 81

{
	mf_status rc;
	const struct locus *locus = env_get_locus(env);

	trace("%s%s:%lu: POLLHOST %s FOR %s FROM %s AS %s",
	      mailfromd_msgid(env_get_context(env)),
	      locus->file, locus->line,
	      email, host,
	      ehlo, mailfrom);

	rc = check_on_host(env, email, host, ehlo, mailfrom);

		if (!(mf_resolved(rc)))
			env_throw(env, rc,                                             "_pollhost: " "unhandled exception %s",mf_status_str(rc));
#line 95
;
#line 95
;
	
	do {
#line 97
push(env, (STKVAL) (rc));
#line 97
return;
#line 97
} while (0);	
}
}

#line 102
void
#line 102
bi__pollmx(eval_environ_t env)
#line 102

#line 102 "bi_poll.m4"
{
#line 102
	
#line 102
char * domain = (char *) get_string_arg(env, 3);
#line 102
        char * email = (char *) get_string_arg(env, 2);
#line 102
        char * ehlo = (char *) get_string_arg(env, 1);
#line 102
        char * mailfrom = (char *) get_string_arg(env, 0);
#line 102
        
#line 102
        adjust_stack(env, 4);
#line 102

#line 102
	if (prog_trace_option & BUILTIN_MASK_poll)
#line 102
		prog_trace(env, "_pollmx %s %s %s %s",domain, email, ehlo, mailfrom);;
#line 102

{
	mf_status rc;
	const struct locus *locus = env_get_locus(env);

	trace("%s%s:%lu: POLLMX %s FOR %s FROM %s AS %s",
	      mailfromd_msgid(env_get_context(env)),
	      locus->file, locus->line,
	      domain, email, ehlo, mailfrom);

	rc = check_mx_records(env, email, domain, ehlo, mailfrom, NULL);

		if (!(mf_resolved(rc)))
			env_throw(env, rc,                                             "_pollmx: " "unhandled exception %s",mf_status_str(rc));
#line 115
;
#line 115
;

	do {
#line 117
push(env, (STKVAL) (rc));
#line 117
return;
#line 117
} while (0);	
}
}


#line 121
void
#line 121
poll_init_builtin()
#line 121
{
#line 121
	#line 19 "bi_poll.m4"
	last_poll_host_loc = builtin_variable_install("last_poll_host", dtype_string, VAR_VOLATILE)->off;
#line 20 "bi_poll.m4"
	last_poll_send_loc = builtin_variable_install("last_poll_send", dtype_string, VAR_VOLATILE)->off;
#line 21 "bi_poll.m4"
	last_poll_recv_loc = builtin_variable_install("last_poll_recv", dtype_string, VAR_VOLATILE)->off;
#line 22 "bi_poll.m4"
	cache_used_loc = builtin_variable_install("cache_used", dtype_number, VAR_VOLATILE)->off;
#line 43 "bi_poll.m4"
va_builtin_install_ex("stdpoll", bi_stdpoll, 0, 0, dtype_number,  3, 0,  dtype_string, dtype_string, dtype_string);
#line 61 "bi_poll.m4"
va_builtin_install_ex("strictpoll", bi_strictpoll, 0, 0, dtype_number,  4, 0,  dtype_string, dtype_string, dtype_string, dtype_string);
#line 81 "bi_poll.m4"
va_builtin_install_ex("_pollhost", bi__pollhost, 0, 0, dtype_number,  4, 0,  dtype_string, dtype_string, dtype_string, dtype_string);
#line 102 "bi_poll.m4"
va_builtin_install_ex("_pollmx", bi__pollmx, 0, 0, dtype_number,  4, 0,  dtype_string, dtype_string, dtype_string, dtype_string);

#line 121 "bi_poll.m4"
		
#line 121
}
#line 0

#line 0

