/* -*- buffer-read-only: t -*- vi: set ro:
#line 426
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
#line 426
*/
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif
#include <sys/types.h>
#include "mailfromd.h"
#include "prog.h"
#include "builtin.h"

#line 17 "bi_sa.m4"
/* This file is part of mailfromd.             -*- c -*-
#line 17
   Copyright (C) 2006, 2007 Sergey Poznyakoff
#line 17

#line 17
   This program is free software; you can redistribute it and/or modify
#line 17
   it under the terms of the GNU General Public License as published by
#line 17
   the Free Software Foundation; either version 2, or (at your option)
#line 17
   any later version.
#line 17

#line 17
   This program is distributed in the hope that it will be useful,
#line 17
   but WITHOUT ANY WARRANTY; without even the implied warranty of
#line 17
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#line 17
   GNU General Public License for more details.
#line 17

#line 17
   You should have received a copy of the GNU General Public License
#line 17
   along with this program; if not, write to the Free Software
#line 17
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#line 17
   MA 02110-1301 USA */

#include <unistd.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <string.h>
#include <signal.h>

static size_t sa_score_loc
#line 27 "bi_sa.m4"
;
static size_t sa_threshold_loc
#line 28 "bi_sa.m4"
;
static size_t sa_keywords_loc
#line 29 "bi_sa.m4"
;
static size_t clamav_virus_name_loc
#line 30 "bi_sa.m4"
;

static int
spamd_connect_tcp(eval_environ_t env, mu_stream_t *stream,
		  char *host, int port)
{
	int rc = mu_tcp_stream_create(stream, host, port, 0);
		if (!(rc == 0))
#line 39
			env_throw(env, mf_failure,  "mu_tcp_stream_create: %s",mu_strerror(rc));
#line 39
;
#line 39
;
	rc = mu_stream_open(*stream);
		if (!(rc == 0))
#line 43
			env_throw(env, mf_failure,  "opening tcp stream: %s",mu_strerror(rc));
#line 43
;
#line 43
;
	return rc;
}

static int
spamd_connect_socket(eval_environ_t env, mu_stream_t *stream, char *path)
{
	int fd, rc;
	FILE *fp;
	struct sockaddr_un addr;
	
	fd = socket(PF_UNIX, SOCK_STREAM, 0);
		if (!(fd >= 0))
			env_throw(env, mf_failure,  "socket: %s",mu_strerror(errno));
#line 56
;
#line 56
;

	memset(&addr, 0, sizeof addr);
	addr.sun_family = AF_UNIX;
	strncpy(addr.sun_path, path, sizeof addr.sun_path - 1);
	addr.sun_path[sizeof addr.sun_path - 1] = 0;
	if (connect(fd, (struct sockaddr *) &addr, sizeof(addr))) {
		close(fd);
			env_throw(env, mf_failure,  "connect: %s",mu_strerror(errno));
#line 64
;
	}

	fp = fdopen(fd, "w+");
	rc = mu_stdio_stream_create(stream, fp, MU_STREAM_RDWR);
	if (rc) {
		fclose(fp);
			env_throw(env, mf_failure,  "mu_stdio_stream_create: %s",mu_strerror(rc));
#line 73
;
	}

	rc = mu_stream_open(*stream);
	if (rc) {
		mu_stream_destroy (stream, mu_stream_get_owner (*stream));
		fclose(fp);
			env_throw(env, mf_failure,  "mu_stream_open: %s",mu_strerror(rc));
#line 82
;
	}
	return rc;
}

static void
spamd_shutdown(mu_stream_t stream, int isfile, int flag)
{
	int fd;
	
	mu_transport_t trans;
	mu_stream_flush(stream);
	mu_stream_get_transport(stream, &trans);
	if (isfile)
		fd = fileno((FILE*)trans);
	else
		fd = (int) trans;
	shutdown(fd, flag);
}

static void
spamd_destroy(mu_stream_t *stream)
{
	mu_stream_close(*stream);
	mu_stream_destroy(stream, mu_stream_get_owner(*stream));
}

static void
spamd_send_command(mu_stream_t stream, const char *fmt, ...)
{
	char buf[512];
	size_t n;
	va_list ap;
	
	va_start (ap, fmt);
	n = vsnprintf (buf, sizeof buf, fmt, ap);
	va_end (ap);
	mu_stream_sequential_write(stream, buf, n);
	mu_stream_sequential_write(stream, "\r\n", 2);
}

static void
spamd_send_stream(mu_stream_t stream, mu_stream_t instr)
{
	size_t size;
	char buf[512];
	
	mu_stream_seek(instr, 0, SEEK_SET);
	while (mu_stream_sequential_readline(instr, buf, sizeof(buf),
					     &size) == 0
	       && size > 0) {
		debug3(80,"<< %*.*s", size, size, buf);
		mu_stream_sequential_write (stream, buf, size);
	}
}

static int
spamd_read_line(mu_stream_t stream, char *buffer, size_t size, size_t *pn)
{
	size_t n = 0;
	int rc = mu_stream_sequential_readline(stream, buffer, size, &n);
	if (rc == 0) {
		if (pn)
			*pn = n;
		while (n > 0 && (buffer[n-1] == '\r' || buffer[n-1] == '\n'))
			n--;
		buffer[n] = 0;
		debug1(80,">> %s", buffer);
	}
	return rc;
}

#define char_to_num(c) (c-'0')

static void
decode_float(long *vn, char *str, int digits)
{
	long v;
	size_t frac = 0;
	size_t base = 1;
	int i;
	int negative = 0;
  
	for (i = 0; i < digits; i++)
		base *= 10;
  
	v = strtol(str, &str, 10);
	if (v < 0) {
		negative = 1;
		v = - v;
	}
  
	v *= base;
	if (*str == '.') {
		for (str++, i = 0; *str && i < digits; i++, str++)
			frac = frac * 10 + char_to_num (*str);
		if (*str) {
			if (char_to_num(*str) >= 5)
				frac++;
		}
		else
			for (; i < digits; i++)
				frac *= 10;
	}
	*vn = v + frac;
	if (negative)
		*vn = - *vn;
}

static int
decode_boolean (char *str)
{
	if (strcasecmp (str, "true") == 0)
		return 1;
	else if (strcasecmp (str, "false") == 0)
		return 0;
	/*else?*/
	return 0;
}

typedef RETSIGTYPE (*signal_handler_fn)(int);

static signal_handler_fn
set_signal_handler (int sig, signal_handler_fn h)
{
#ifdef HAVE_SIGACTION
	struct sigaction act, oldact;
	act.sa_handler = h;
	sigemptyset (&act.sa_mask);
	act.sa_flags = 0;
	sigaction (sig, &act, &oldact);
	return oldact.sa_handler;
#else
	return signal (sig, h);
#endif
}

static int got_sigpipe;

static RETSIGTYPE
sigpipe_handler (int sig)
{
	got_sigpipe = 1;
}

mu_stream_t
open_connection(eval_environ_t env, char *urlstr, int *isfile, char **phost)
{
	char *path = NULL;
	short port = 0;
	mu_stream_t str = NULL;
	int rc;
	
	if (urlstr[0] == '/') {
		path = strdup(urlstr);
		if (!path)
			runtime_error(env, "Not enough memory");
	} else {
		char buffer[10];
		mu_url_t url = NULL;
		
		rc = mu_url_create(&url, urlstr);
		if (rc)
				env_throw(env, mf_failure,  "cannot create url from `%s': %s",urlstr,mu_strerror(rc));
#line 247
;
		
		if (rc = mu_url_parse(url)) {
			mu_url_destroy(&url);
				env_throw(env, mf_url,  "%s: error parsing url: %s",urlstr,mu_strerror(rc));
#line 253
;
		}

		if (rc = mu_url_get_scheme(url, buffer, sizeof buffer, NULL)) {
			mu_url_destroy(&url);
				env_throw(env, mf_url,  "%s: cannot get scheme: %s",urlstr,mu_strerror(rc));
#line 260
;
		}

		if (strcmp(buffer, "file") == 0
		    || strcmp(buffer, "socket") == 0) {
			size_t size;
			if (rc = mu_url_get_path(url, NULL, 0, &size)) {
					env_throw(env, mf_url,  "%s: cannot get path: %s",urlstr,mu_strerror(rc));
#line 269
;
			}
			path = malloc(size + 1);
			if (!path) {
				mu_url_destroy(&url);
				runtime_error(env, "Not enough memory");
			}
			mu_url_get_path(url, path, size + 1, NULL);
		} else if (strcmp(buffer, "tcp") == 0) {
			size_t size;
			long n;

			if (mu_url_get_port(url, &n)) {
				mu_url_destroy(&url);
					env_throw(env, mf_url,  "%s: cannot get port: %s",urlstr,mu_strerror(rc));
#line 285
;
			}

			if (n == 0 || (port = n) != n) {
				mu_url_destroy(&url);
					env_throw(env, mf_range,  "port out of range: %s",mu_strerror(rc));
#line 292
;
			}
			
			if (rc = mu_url_get_host(url, NULL, 0, &size)) {
				mu_url_destroy(&url);
					env_throw(env, mf_url,  "%s: cannot get host: %s",urlstr,mu_strerror(rc));
#line 299
;
			}
			path = malloc(size + 1);
			if (!path) {
				mu_url_destroy(&url);
				runtime_error(env, "Not enough memory");
			}
			mu_url_get_host(url, path, size + 1, NULL);
		} else
				env_throw(env, mf_url,  "Invalid url: %s",buffer);
;

		mu_url_destroy(&url);
	}

	if (port == 0) {
		rc = spamd_connect_socket(env, &str, path);
		*isfile = 1;
	} else {
		rc = spamd_connect_tcp(env, &str, path, port);
		*isfile = 0;
	}
	
	if (rc == 0 && phost) {
		if (port) {
			*phost = path;
			path = NULL;
		} else
			*phost = NULL;
	}

	free(path);

	return str;
}	


	
void
#line 337
bi_sa(eval_environ_t env)
#line 337

#line 337 "bi_sa.m4"
{
#line 337
	
#line 337
char * urlstr = (char *) get_string_arg(env, 1);
#line 337
        long  prec = (long ) get_numeric_arg(env, 0);
#line 337
        
#line 337
        adjust_stack(env, 2);
#line 337

#line 337
	if (prog_trace_option & BUILTIN_MASK_sa)
#line 337
		prog_trace(env, "sa %s %lu",urlstr, prec);;
#line 337

{
	mu_off_t msize;
	size_t size;
	mu_stream_t mstr = env_get_stream(env);
	mu_stream_t ostr;
	signal_handler_fn handler;
	char buffer[512];
	char version_str[19];
	char spam_str[6], score_str[21], threshold_str[21];
	long version;
	int result;
	long score, threshold;
	int isfile;
	
	ostr = open_connection(env, urlstr, &isfile, NULL);
	mu_stream_size(mstr, &msize);
	spamd_send_command(ostr, "SYMBOLS SPAMC/1.2");
	spamd_send_command(ostr, "Content-length: %lu",
			   (unsigned long) msize);
	/*FIXME: spamd_send_command(ostr, "User: %s", ??) */
	got_sigpipe = 0;
	handler = set_signal_handler(SIGPIPE, sigpipe_handler);
	spamd_send_command(ostr, "");
	spamd_send_stream(ostr, mstr);
	spamd_shutdown(ostr, isfile, SHUT_WR);
	set_signal_handler(SIGPIPE, handler);
	
	spamd_read_line(ostr, buffer, sizeof buffer, NULL);
	if (got_sigpipe) {
		spamd_destroy(&ostr);
			env_throw(env, mf_failure,                                             "sa: " "remote side has closed connection");
#line 368
;
	}

	if (sscanf(buffer, "SPAMD/%18s %d %*s", version_str, &result) != 2) {
		spamd_destroy(&ostr);
			env_throw(env, mf_failure,                                             "sa: " "spamd responded with bad string '%s'",buffer);
#line 375
;
	}

	decode_float(&version, version_str, 1);
	if (version < 10) {
		spamd_destroy(&ostr);
			env_throw(env, mf_failure,                                             "sa: " "unsupported SPAMD version: %s",version_str);
#line 383
;
	}

	spamd_read_line(ostr, buffer, sizeof buffer, NULL);
	if (sscanf (buffer, "Spam: %5s ; %20s / %20s",
		    spam_str, score_str, threshold_str) != 3) {
		spamd_destroy(&ostr);
			env_throw(env, mf_failure,                                             "sa: " "spamd responded with bad Spam header "
#line 392
			 "'%s'",buffer);
#line 392
;
	}

	result = decode_boolean(spam_str);
	decode_float(&score, score_str, prec);
	decode_float(&threshold, threshold_str, prec);

	/* Skip newline */
	spamd_read_line(ostr, buffer, sizeof buffer, NULL);
	/* Read symbol list */
	spamd_read_line(ostr, buffer, sizeof buffer, &size);

	*env_data_ref(env, sa_score_loc) = (STKVAL) (score);
	*env_data_ref(env, sa_threshold_loc) = (STKVAL) (threshold);
	
#line 406
{ size_t off;
#line 406
  if (buffer)
#line 406
     strcpy((char*)env_data_ref(env, off = heap_reserve(env, strlen(buffer) + 1)), buffer);
#line 406
  else
#line 406
     off = 0;
#line 406
  *env_data_ref(env, sa_keywords_loc) = (STKVAL) (off); }
#line 406
;
	
	while (spamd_read_line(ostr, buffer, sizeof buffer, &size) == 0
	       && size > 0)
		/* Drain input */;
  	spamd_destroy(&ostr);
	
	do {
#line 413
push(env, (STKVAL) (result));
#line 413
return;
#line 413
} while (0);
}
}


	
void
#line 419
bi_clamav(eval_environ_t env)
#line 419

#line 419 "bi_sa.m4"
{
#line 419
	
#line 419
char * urlstr = (char *) get_string_arg(env, 0);
#line 419
        
#line 419
        adjust_stack(env, 1);
#line 419

#line 419
	if (prog_trace_option & BUILTIN_MASK_sa)
#line 419
		prog_trace(env, "clamav %s",urlstr);;
#line 419

{
	mu_stream_t mstr = env_get_stream(env);
	mu_stream_t cstr, dstr;
	char buffer[512];
	char *host;
	unsigned short port;
	int rc;
	signal_handler_fn handler;
	char *p;
	int isfile;
	
	cstr = open_connection(env, urlstr, &isfile, &host);

	spamd_send_command(cstr, "STREAM");
	spamd_read_line(cstr, buffer, sizeof buffer, NULL);
	if (sscanf(buffer, "PORT %hu\n", &port) != 1) {
		spamd_destroy(&cstr);
			env_throw(env, mf_failure,                                             "clamav: " "bad response from clamav: expected `PORT'"
#line 439
			 " but found `%s'",buffer);
#line 439
;
	}

	if (!host) 
		host = strdup("127.0.0.1"); /* FIXME */
	
	rc = mu_tcp_stream_create(&dstr, host, port, 0);
	free(host);
	if (rc) {
		spamd_destroy(&cstr);
			env_throw(env, mf_failure,                                             "clamav: " "mu_tcp_stream_create: %s",mu_strerror(rc));
#line 451
;
	}

	rc = mu_stream_open(dstr);
	if (rc) {
		spamd_destroy(&cstr);
		mu_stream_destroy(&dstr, mu_stream_get_owner(dstr));
			env_throw(env, mf_failure,                                             "clamav: " "opening tcp stream: %s",mu_strerror(rc));
#line 460
;
	}

	handler = set_signal_handler(SIGPIPE, sigpipe_handler);
	spamd_send_stream(dstr, mstr);
	spamd_shutdown(dstr, 0, SHUT_WR);
	set_signal_handler(SIGPIPE, handler);

	rc = spamd_read_line(cstr, buffer, sizeof buffer, NULL);
	spamd_destroy(&cstr);
		if (!(rc == 0))
			env_throw(env, mf_failure,                                             "clamav: " "error reading clamav response: %s",mu_strerror(rc));
#line 471
;
#line 471
;

	p = strrchr(buffer, ' ');
        	if (!(p))
			env_throw(env, mf_failure,                                             "clamav: " "unknown clamav response: %s",buffer);
#line 475
;
#line 475
;
	++p;
	if (strncmp(p, "OK", 2) == 0)
		rc = 0;
	else if (strncmp(p, "FOUND", 5) == 0) {
		char *s;
			
		*--p = '\0';
		s = strrchr(buffer, ' ');
		if (!s)
			s = buffer;
		else
			s++;
		
#line 488
{ size_t off;
#line 488
  if (s)
#line 488
     strcpy((char*)env_data_ref(env, off = heap_reserve(env, strlen(s) + 1)), s);
#line 488
  else
#line 488
     off = 0;
#line 488
  *env_data_ref(env, clamav_virus_name_loc) = (STKVAL) (off); }
#line 488
;

		debug2(2,
		       "%sclamav found %s",
		       mailfromd_msgid(env_get_context(env)),
		       s);
		rc = 1;
	} else if (strncmp(p, "ERROR", 5) == 0) {
		/* FIXME: mf code */
			env_throw(env, mf_failure,                                             "clamav: " "clamav error: %s",buffer);
#line 499
;
	} else {
			env_throw(env, mf_failure,                                             "clamav: " "unknown clamav response: %s",buffer);
#line 503
;
	}

	do {
#line 506
push(env, (STKVAL) (rc));
#line 506
return;
#line 506
} while (0);
}
}


#line 510
void
#line 510
sa_init_builtin()
#line 510
{
#line 510
	#line 27 "bi_sa.m4"
	sa_score_loc = builtin_variable_install("sa_score", dtype_number, VAR_VOLATILE)->off;
#line 28 "bi_sa.m4"
	sa_threshold_loc = builtin_variable_install("sa_threshold", dtype_number, VAR_VOLATILE)->off;
#line 29 "bi_sa.m4"
	sa_keywords_loc = builtin_variable_install("sa_keywords", dtype_string, VAR_VOLATILE)->off;
#line 30 "bi_sa.m4"
	clamav_virus_name_loc = builtin_variable_install("clamav_virus_name", dtype_string, VAR_VOLATILE)->off;
#line 337 "bi_sa.m4"
va_builtin_install_ex("sa", bi_sa, EXMASK(smtp_state_eom), 1, dtype_number,  2, 0,  dtype_string, dtype_number);
#line 419 "bi_sa.m4"
va_builtin_install_ex("clamav", bi_clamav, EXMASK(smtp_state_eom), 1, dtype_number,  1, 0,  dtype_string);

#line 510 "bi_sa.m4"
		
#line 510
}

#line 0

#line 0

